## openqa 4.6.1745831108.e60c89e32

=== Makefile ===
RETRY ?= 0
# STABILITY_TEST: Set to 1 to fail as soon as any of the RETRY fails rather
# than succeed if any of the RETRY succeed
STABILITY_TEST ?= 0
# KEEP_DB: Set to 1 to keep the test database process spawned for tests. This
# can help with faster re-runs of tests but might yield inconsistent results
KEEP_DB ?= 0
# CONTAINER_TEST: Set to 0 to exclude container tests needing a container
# runtime environment
CONTAINER_TEST ?= 1
# HELM_TEST: Set to 0 to exclude helm tests needing a kubernetes cluster
HELM_TEST ?= 1
# TESTS: Specify individual test files in a space separated lists. As the user
# most likely wants only the mentioned tests to be executed and no other
# checks this implicitly disables CHECKSTYLE
TESTS ?=
# EXTRA_PROVE_ARGS: Additional prove arguments to pass
EXTRA_PROVE_ARGS ?=
# PROVE: Test application for Perl tests
PROVE ?= prove
ifeq ($(TESTS),)
PROVE_ARGS ?= --trap -r ${EXTRA_PROVE_ARGS} t
else
CHECKSTYLE ?= 0
PROVE_ARGS ?= --trap ${EXTRA_PROVE_ARGS} $(TESTS)
endif
PROVE_LIB_ARGS ?= -l
TEST_PG_PATH ?= /dev/shm/tpg
# TIMEOUT_M: Timeout for one retry of tests in minutes
TIMEOUT_M ?= 60
ifeq ($(CI),)
SCALE_FACTOR ?= 1
else
SCALE_FACTOR ?= 2
endif
TIMEOUT_RETRIES ?= $$((${TIMEOUT_M} * ${SCALE_FACTOR} * (${RETRY} + 1) ))m
CRE ?= podman
# avoid localized error messages (that are matched against in certain cases)
LC_ALL = C.utf8
LANGUAGE =
LANG = C.utf8
mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
current_dir := $(patsubst %/,%,$(dir $(mkfile_path)))
unstables := $(shell cat tools/unstable_tests.txt | tr '\n' :)
shellfiles := $$(file --mime-type script/* t/* container/worker/*.sh tools/* | sed -n 's/^\(.*\):.*text\/x-shellscript.*$$/\1/p')

# tests need these environment variables to be unset
OPENQA_BASEDIR =
OPENQA_CONFIG =
OPENQA_SCHEDULER_HOST =
OPENQA_WEB_SOCKETS_HOST =
OPENQA_SCHEDULER_STARVATION_PROTECTION_PRIORITY_OFFSET =

# change if os-autoinst project root is different from '../os-autoinst'
OS_AUTOINST_BASEDIR =

.PHONY: help
help:
	@echo Call one of the available targets:
	@sed -n 's/\(^[^.#[:space:]A-Z]*\):.*$$/\1/p' Makefile | uniq
	@echo See docs/Contributing.asciidoc for more details

.PHONY: install-generic
install-generic:
	./tools/generate-packed-assets
	for i in lib public script templates assets; do \
		mkdir -p "$(DESTDIR)"/usr/share/openqa/$$i ;\
		cp -a $$i/* "$(DESTDIR)"/usr/share/openqa/$$i ;\
	done
	for f in $(shell perl -Ilib -mOpenQA::Assets -e OpenQA::Assets::list); do \
		install -m 644 -D --target-directory="$(DESTDIR)/usr/share/openqa/$${f%/*}" "$$f";\
	done

	for i in db images testresults pool ; do \
		mkdir -p "$(DESTDIR)"/var/lib/openqa/$$i ;\
	done
# shared dirs between openQA web and workers + compatibility links
	for i in factory tests; do \
		mkdir -p "$(DESTDIR)"/var/lib/openqa/share/$$i ;\
		ln -sfn /var/lib/openqa/share/$$i "$(DESTDIR)"/var/lib/openqa/$$i ;\
	done
	for i in iso hdd repo other; do \
		mkdir -p "$(DESTDIR)"/var/lib/openqa/share/factory/$$i ;\
	done
	for i in script; do \
		ln -sfn /usr/share/openqa/$$i "$(DESTDIR)"/var/lib/openqa/$$i ;\
	done
#
	install -d -m 755 "$(DESTDIR)"/etc/apache2/vhosts.d
	for i in openqa-common.inc openqa.conf.template openqa-ssl.conf.template; do \
		install -m 644 etc/apache2/vhosts.d/$$i "$(DESTDIR)"/etc/apache2/vhosts.d ;\
	done

	install -d -m 755 "$(DESTDIR)"/etc/nginx/vhosts.d
	for i in openqa-locations.inc openqa-upstreams.inc openqa.conf.template; do \
		install -m 644 etc/nginx/vhosts.d/$$i "$(DESTDIR)"/etc/nginx/vhosts.d ;\
	done

	for prefix in usr/etc etc; do \
		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa ;\
		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa/client.conf.d ;\
		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa/workers.ini.d ;\
		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa/openqa.ini.d ;\
		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa/database.ini.d ;\
	done
	install -D -m 644 etc/openqa/client.conf "$(DESTDIR)"/usr/share/doc/openqa/examples/client.conf
	install -D -m 644 etc/openqa/workers.ini "$(DESTDIR)"/usr/share/doc/openqa/examples/workers.ini
	install -D -m 644 etc/openqa/openqa.ini "$(DESTDIR)"/usr/share/doc/openqa/examples/openqa.ini
	install -D -m 644 etc/openqa/database.ini "$(DESTDIR)"/usr/share/doc/openqa/examples/database.ini

	install -D -m 644 etc/logrotate.d/openqa "$(DESTDIR)"/etc/logrotate.d/openqa
#
	install -d -m 755 "$(DESTDIR)"/usr/lib/systemd/system
	install -d -m 755 "$(DESTDIR)"/usr/lib/systemd/system-generators
	install -d -m 755 "$(DESTDIR)"/usr/lib/tmpfiles.d
	eval "$$(perl -V:installvendorlib)" && sed -i -e "s^installvendorlib^$$installvendorlib^" systemd/openqa-minion-restart.path
	for i in systemd/*.{service,slice,target,timer,path}; do \
		install -m 644 $$i "$(DESTDIR)"/usr/lib/systemd/system ;\
	done
	ln -s openqa-worker-plain@.service "$(DESTDIR)"/usr/lib/systemd/system/openqa-worker@.service
	sed \
		-e 's_^\(ExecStart=/usr/share/openqa/script/worker\) \(--instance %i\)$$_\1 --no-cleanup \2_' \
		-e '/^$$/N;/\[Service\]/iConflicts=openqa-worker-plain@.service' \
		systemd/openqa-worker-plain@.service > "$(DESTDIR)"/usr/lib/systemd/system/openqa-worker-no-cleanup@.service
	sed \
		-e '/\[Service\]/aEnvironment=OPENQA_WORKER_TERMINATE_AFTER_JOBS_DONE=1' \
		-e '/ExecStart=/aExecReload=\/bin\/kill -HUP $$MAINPID' \
		-e 's/Restart=.*/Restart=always/' \
		-e '/^$$/N;/\[Service\]/iConflicts=openqa-worker-plain@.service' \
		systemd/openqa-worker-plain@.service > "$(DESTDIR)"/usr/lib/systemd/system/openqa-worker-auto-restart@.service
	install -m 755 systemd/systemd-openqa-generator "$(DESTDIR)"/usr/lib/systemd/system-generators
	install -m 644 systemd/tmpfiles-openqa.conf "$(DESTDIR)"/usr/lib/tmpfiles.d/openqa.conf
	install -m 644 systemd/tmpfiles-openqa-webui.conf "$(DESTDIR)"/usr/lib/tmpfiles.d/openqa-webui.conf
	install -d -m 755 "$(DESTDIR)"/usr/lib/systemd/system/openqa-gru.service.requires
	ln -s ../postgresql.service "$(DESTDIR)"/usr/lib/systemd/system/openqa-gru.service.requires/postgresql.service
	install -d -m 755 "$(DESTDIR)"/usr/lib/systemd/system/openqa-scheduler.service.requires
	ln -s ../postgresql.service "$(DESTDIR)"/usr/lib/systemd/system/openqa-scheduler.service.requires/postgresql.service
	install -d -m 755 "$(DESTDIR)"/usr/lib/systemd/system/openqa-websockets.service.requires
	ln -s ../postgresql.service "$(DESTDIR)"/usr/lib/systemd/system/openqa-websockets.service.requires/postgresql.service
	install -D -m 644 usr/lib/sysctl.d/01-openqa-reload-worker-auto-restart.conf "$(DESTDIR)"/usr/lib/sysctl.d/01-openqa-reload-worker-auto-restart.conf
#
# install openQA apparmor profile
	install -d -m 755 "$(DESTDIR)"/etc/apparmor.d
	install -m 644 profiles/apparmor.d/usr.share.openqa.script.openqa "$(DESTDIR)"/etc/apparmor.d
	install -m 644 profiles/apparmor.d/usr.share.openqa.script.worker "$(DESTDIR)"/etc/apparmor.d
	install -d -m 755 "$(DESTDIR)"/etc/apparmor.d/local
	install -m 644 profiles/apparmor.d/local/usr.share.openqa.script.openqa "$(DESTDIR)"/etc/apparmor.d/local
	install -m 644 profiles/apparmor.d/local/usr.share.openqa.script.worker "$(DESTDIR)"/etc/apparmor.d/local

	cp -Ra dbicdh "$(DESTDIR)"/usr/share/openqa/dbicdh

	install -d -m 755 "$(DESTDIR)"/usr/lib/sysusers.d/
	install    -m 644 usr/lib/sysusers.d/openQA-worker.conf "$(DESTDIR)"/usr/lib/sysusers.d/
	install    -m 644 usr/lib/sysusers.d/geekotest.conf "$(DESTDIR)"/usr/lib/sysusers.d/

# Additional services which have a strong dependency on SUSE/openSUSE and do not
# make sense for other distributions
.PHONY: install-opensuse
install-opensuse: install-generic
	for i in systemd/opensuse/*.{service,timer}; do \
		install -m 644 $$i "$(DESTDIR)"/usr/lib/systemd/system ;\
	done

# Match suse and opensuse
os := $(shell grep suse /etc/os-release)
.PHONY: install
ifeq ($(os),)
install: install-generic
else
install: install-opensuse
endif

# Ensure npm packages are installed and up-to-date (unless local-npm-registry is installed; in this case we can
# assume installing npm packages is taken care of separately, e.g. in builds on OBS)
node_modules: package-lock.json
	@which local-npm-registry >/dev/null 2>&1 || npm install --no-audit --no-fund
	@touch node_modules

.PHONY: test
ifeq ($(TRAVIS),true)
test: run-tests-within-container
else
ifeq ($(CHECKSTYLE),0)
checkstyle_tests =
else
checkstyle_tests = test-checkstyle-standalone
endif
test: $(checkstyle_tests) test-with-database
ifeq ($(CONTAINER_TEST),1)
ifeq ($(TESTS),)
test: test-containers-compose
endif
endif
ifeq ($(HELM_TEST),1)
ifeq ($(TESTS),)
test: test-helm-chart
endif
endif
endif

.PHONY: test-checkstyle
test-checkstyle: test-checkstyle-standalone test-tidy-compile

.PHONY: test-t
test-t: node_modules
	$(MAKE) test-with-database TIMEOUT_M=25 PROVE_ARGS="$$HARNESS t/*.t" GLOBIGNORE="t/*tidy*:t/*compile*:$(unstables)"

.PHONY: test-heavy
test-heavy: node_modules
	$(MAKE) test-with-database HEAVY=1 TIMEOUT_M=25 PROVE_ARGS="$$HARNESS $$(grep -l HEAVY=1 t/*.t | tr '\n' ' ')"

.PHONY: test-ui
test-ui: node_modules
	$(MAKE) test-with-database TIMEOUT_M=25 PROVE_ARGS="$$HARNESS t/ui/*.t" GLOBIGNORE="t/*tidy*:t/*compile*:$(unstables)"

.PHONY: test-api
test-api: node_modules
	$(MAKE) test-with-database TIMEOUT_M=20 PROVE_ARGS="$$HARNESS t/api/*.t" GLOBIGNORE="t/*tidy*:t/*compile*:$(unstables)"

# put unstable tests in tools/unstable_tests.txt and uncomment in circle CI config to handle unstables with retries
.PHONY: test-unstable
test-unstable: node_modules
	for f in $$(cat tools/unstable_tests.txt); do $(MAKE) test-with-database COVERDB_SUFFIX=$$(echo $${COVERDB_SUFFIX}_$$f | tr '/' '_') TIMEOUT_M=10 PROVE_ARGS="$$HARNESS $$f" RETRY=5 || exit; done

.PHONY: test-fullstack
test-fullstack: node_modules
	$(MAKE) test-with-database FULLSTACK=1 TIMEOUT_M=30 PROVE_ARGS="$$HARNESS t/full-stack.t t/33-developer_mode.t"

.PHONY: test-fullstack-unstable
test-fullstack-unstable: node_modules
	$(MAKE) test-with-database FULLSTACK=1 TIMEOUT_M=15 PROVE_ARGS="$$HARNESS t/05-scheduler-full.t" RETRY=5

# we have apparently-redundant -I args in PERL5OPT here because Docker
# only works with one and Fedora's build system only works with the other
.PHONY: test-with-database
test-with-database: node_modules setup-database
	$(MAKE) test-unit-and-integration TEST_PG="DBI:Pg:dbname=openqa_test;host=$(TEST_PG_PATH)"
	-[ $(KEEP_DB) = 1 ] || pg_ctl -D $(TEST_PG_PATH) stop

.PHONY: test-unit-and-integration
test-unit-and-integration: node_modules
	export GLOBIGNORE="$(GLOBIGNORE)";\
	export DEVEL_COVER_DB_FORMAT=JSON;\
	export PERL5OPT="$(COVEROPT)$(PERL5OPT) -It/lib -I$(PWD)/t/lib -I$(PWD)/external/os-autoinst-common/lib -MOpenQA::Test::PatchDeparse";\
	RETRY=${RETRY} HOOK=./tools/delete-coverdb-folder timeout -s SIGINT -k 5 -v ${TIMEOUT_RETRIES} tools/retry "${PROVE}" ${PROVE_LIB_ARGS} ${PROVE_ARGS}

.PHONY: setup-database
setup-database:
	test -d $(TEST_PG_PATH) && (pg_ctl -D $(TEST_PG_PATH) -s status >&/dev/null || pg_ctl -D $(TEST_PG_PATH) -s start) || ./t/test_postgresql $(TEST_PG_PATH)

# prepares running the tests within a container (eg. pulls os-autoinst) and then runs the tests considering
# the test matrix environment variables
# note: This is supposed to run within the container unlike `launch-container-to-run-tests-within`
#       which launches the container.
.PHONY: run-tests-within-container
run-tests-within-container:
	tools/run-tests-within-container

ifeq ($(COVERAGE),1)
COVERDB_SUFFIX ?=
# We use JSON::PP because there is a bug producing a (harmless) 'redefined'
# warning when using Devel::Cover and Cpanel::JSON::XS
# https://progress.opensuse.org/issues/90371
#
# CoverageWorkaround: We use a workaround with Syntax::Keyword::Try::Deparse
# because we would get warnings:
#     unexpected OP_CUSTOM (catch) at .../B/Deparse.pm line 1667.
# because Feature::Compat::Try uses OP_CUSTOM for perl < 5.40
# https://metacpan.org/pod/Feature::Compat::Try#COMPATIBILITY-NOTES
# https://rt.cpan.org/Transaction/Display.html?id=1992941

=== debian/changelog ===
openqa (4.6.1745831108.e60c89e32-1~fto12+1) bookworm-fasttrack; urgency=medium

  * Update to new upstream version 4.6.1745831108.e60c89e32.
  * Build for bookworm-fasttrack.
  * salsa CI: build in a backport environment
  * fasttrack: ignore backport related test warnings

 -- Philip Hands <phil@hands.com>  Sat, 31 May 2025 20:04:18 +0200

=== debian/control ===
Source: openqa
Section: devel
Priority: optional
Maintainer: Philip Hands <phil@hands.com>
Uploaders: Adam Majer <adamm@debian.org>,
           Andrew Lee (李健秋) <ajqlee@debian.org>,
           Hideki Yamane <henrich@debian.org>,
Build-Depends: debhelper-compat (= 13),
               debhelper (>= 13.11.6),
               dh-sequence-nodejs,
               dh-exec,
               dh-apparmor,
               os-autoinst,
               systemd-dev,
               ruby-sass,
               fdupes,
               libmojolicious-perl (>= 9.34),
### Bug#839569
#              libselenium-remote-driver-perl (>= 1.0),
### for test&runtime
               libarchive-extract-perl,
               libbsd-resource-perl,
#               libcache-cache-perl,
#               libcgi-pm-perl,
               libclone-perl,
               libconfig-inifiles-perl,
#               libconfig-tiny-perl,
               libcrypt-dh-gmp-perl,
               libcss-minifier-xs-perl (>= 0.01),
               libdbd-sqlite3-perl,
               libdbix-class-perl,
               libdbix-class-deploymenthandler-perl,
               libdbix-class-dynamicdefault-perl,
               libdbix-class-optimisticlocking-perl,
               libdata-dump-perl,
               libdata-optlist-perl,
               libdatetime-perl,
               libdatetime-format-sqlite-perl,
               libdatetime-format-pg-perl,
               libcpanel-json-xs-perl,
               libtest-exception-perl,
               libpod-pom-perl,
               libmojo-sqlite-perl,
               libmojo-pg-perl,
               libmojo-ioloop-readwriteprocess-perl (>= 0.34),
               libdbix-class-schema-config-perl,
#               libdbix-class-schema-loader-perl,
               libfile-copy-recursive-perl,
#               libio-socket-inet6-perl,
               libio-socket-ssl-perl,
               libipc-run-perl,
               libjavascript-minifier-xs-perl (>= 0.11),
               libjson-perl,
               libjson-xs-perl,
               liblist-moreutils-perl,
               libmro-compat-perl,
               libmodule-implementation-perl,
               libmodule-load-conditional-perl,
               libmodule-runtime-perl,
               libmojo-rabbitmq-client-perl,
               libmojolicious-plugin-assetpack-perl (>= 1.36),
#               libmojolicious-plugin-renderfile-perl,
               libnamespace-clean-perl,
               libnet-dbus-perl,
               libnet-openid-consumer-perl,
               libpackage-stash-perl,
               libparams-util-perl,
               libparams-validate-perl,
               libregexp-common-perl,
               libscalar-list-utils-perl,
               libsort-versions-perl,
               libsql-splitstatement-perl,
               libsql-translator-perl,
               libsub-install-perl,
               libsub-name-perl,
               libtest-compile-perl,
               libtest-simple-perl,
               libtext-markdown-perl,
               libtime-parsedate-perl,
               libtime-moment-perl,
               libtimedate-perl,
               liburi-perl,
               libwww-perl,
               perl,
               libminion-perl (>= 10.25),
               node-d3,
               node-dagre-d3-renderer,
               node-anser,
### for testcases
               libperl-critic-perl <!nocheck>,
               libperl-critic-community-perl <!nocheck>,
               libcommonmark-perl <!nocheck>,
               libgetopt-long-descriptive-perl <!nocheck>,
               libmojolicious-plugin-oauth2-perl <!nocheck>,
               libtest-fatal-perl <!nocheck>,
               libtest-mockmodule-perl <!nocheck>,
               libtest-mockobject-perl <!nocheck>,
               libtest-output-perl <!nocheck>,
               libtest-pod-perl <!nocheck>,
               libtest-strict-perl <!nocheck>,
               libtest-warnings-perl <!nocheck>,
               libyaml-libyaml-perl <!nocheck>,
               libjson-validator-perl <!nocheck>,
               libminion-backend-sqlite-perl <!nocheck>,
               postgresql <!nocheck>,
               rsync <!nocheck>,
               curl <!nocheck>,
               shellcheck <!nocheck>,
               jsbeautifier <!nocheck>,
               libclass-c3-componentised-perl <!nocheck>,
               libtest-most-perl <!nocheck>,
               libyaml-pp-perl <!nocheck>,
               python3 <!nocheck>,
               python3-requests <!nocheck>,
               yamllint <!nocheck>,
               libfilesys-df-perl <!nocheck>,
               libfile-map-perl <!nocheck>,
               libtext-glob-perl <!nocheck>,
               libaliased-perl <!nocheck>,
               libarchive-tools <!nocheck>,
               libfeature-compat-try-perl <!nocheck>,
#              for avoiding assetpack downloads
               fonts-fork-awesome,
               fonts-roboto-fontface,
               libjs-chosen,
               libjs-jquery-datatables,
               node-bootstrap (>= 5.3.3+dfsg-1~),
               libjs-codemirror,
               libjs-jquery (>= 3.6.0),
               libjs-jquery-timeago,
               node-popper2,
               node-jquery-ujs,
               node-ace-builds,
# The following is just for testing behaviour relative to new upstream versions.
# Never define profiles 'x-with-npm' or 'x-npm-only' for real package builds.
               npm <x-with-npm>,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://open.qa
Vcs-Git: https://salsa.debian.org/debian/openqa.git
Vcs-Browser: https://salsa.debian.org/debian/openqa

Package: openqa
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
         openqa-common (>= ${binary:Version}),
         openqa-client (>= ${binary:Version}),
         sqlite3, git, optipng, dbus,
         liburi-perl,
         liblwp-protocol-https-perl,
         libdbix-class-perl (>= 0.082801),
         libsql-splitstatement-perl,
         libdbix-class-deploymenthandler-perl,
         libmojo-sqlite-perl,
         libjson-validator-perl,
         libtext-diff-perl,
         libyaml-pp-perl,
         libdatetime-format-pg-perl,
         libminion-perl (>= 10.25),
         libmojo-pg-perl,
         libcommonmark-perl,
         postgresql,
         libclass-c3-componentised-perl,
         fonts-fork-awesome,
         fonts-roboto-fontface,
         libjs-jquery-datatables,
         libjs-codemirror,
         libjs-jquery,
         libjs-jquery-timeago,
         node-popper2,
         node-jquery-ujs (>= 1.2.3-1),
         node-bootstrap (>= 5.3.3+dfsg-1~),
         node-ace-builds,
         node-d3,
         node-dagre-d3-renderer,
         node-anser,
Recommends: apparmor-profiles, apparmor-utils,
            apache2, logrotate,
            libdbd-pg-perl,
            libmojolicious-plugin-oauth2-perl,
Description: automatic Operating System testing framework (webUI & scheduler)
 openQA is a testing framework that allows you to run tests on pretty-much
 anything that you can get 'remote' control of (most often, anything you can run
 in a VM and point VNC at). This allows testing of things including GUI
 applications, system boot-up (BIOS, bootloaders, kernels), installers and whole
 operating systems.
 .
 Tests (using Perl syntax) generally consist mostly of sequences of code like:
   assert_and_click 'some_icon';
   assert_screen 'some_prompt';
   send_key 'ret';
 which are run using the os-autoinst test engine, by a worker. The tags named in
 scripts can then be associated with 'needles' (elements of screenshots) via the
 webUI (either from past tests, or while controlling a live test). Other testing
 possibilities include: serial-connected headless systems, multi-host networked
 tests, and non-VM 'real' systems.
 .
 This package includes the job scheduler, the elements providing the services to
 allow workers to run tests and upload results, and the Web-based user
 interface.

Package: openqa-common
Architecture: all
Depends: ${misc:Depends},
         ${perl:Depends},
         libmojolicious-perl (>= 9.34),
         libjs-chosen,
### for test&runtime
         libdbd-sqlite3-perl,
         libdbix-class-perl (>= 0.082801),
         libconfig-inifiles-perl,
         libsql-translator-perl,
         libdatetime-format-sqlite-perl,
         libfile-copy-recursive-perl,
         libmojolicious-plugin-renderfile-perl,
         libmojolicious-plugin-assetpack-perl (>= 1.36),
         libaliased-perl,
         libconfig-tiny-perl,
         libdbix-class-dynamicdefault-perl,
         libdbix-class-schema-config-perl,
         libdbix-class-optimisticlocking-perl,
         libio-socket-ssl-perl,
         libdata-dump-perl,
         libtext-markdown-perl,
         libnet-dbus-perl,
         libipc-run-perl,
         libarchive-extract-perl,
         libcss-minifier-xs-perl (>= 0.01),
         libjavascript-minifier-xs-perl,
         libmojo-rabbitmq-client-perl,
         libtime-parsedate-perl,
         libsort-versions-perl,
         libbsd-resource-perl,
         libnet-openid-consumer-perl,
         libpod-pom-perl,
         libregexp-common-perl,
         libjson-validator-perl,
         libfilesys-df-perl,
         libtime-moment-perl,
         libcpanel-json-xs-perl,
         libmoose-perl,
Recommends:
         git-lfs,
Description: automatic Operating System testing framework (common files)
 This package contains shared resources for openQA web front-end and openQA
 workers.
 .
 openQA is a testing framework that allows you to run tests on pretty-much
 anything that you can 'remotely' control. For instance, a VM that can be
 accessed via VNC.

Package: openqa-client
Architecture: all
Depends: ${misc:Depends},
         ${perl:Depends},
         libjson-perl,
         libconfig-inifiles-perl,
         libdata-dump-perl,
         libmojolicious-perl (>= 9.34),
         openqa-common (= ${binary:Version}),
Suggests: python3,
Description: automatic Operating System testing framework (utilities)
 This package includes scripts such as 'openqa-cli' and 'openqa-clone-job' to
 provide easy control of openQA servers, via the REST API, as well as commands
 useful when administering an OpenQA server.
 .
 openQA is a testing framework that allows you to run tests on pretty-much
 anything that you can 'remotely' control. For instance, a VM that can be
 accessed via VNC.

Package: openqa-worker
Architecture: all
Pre-Depends: openqa-common (>= ${binary:Version}),
Depends: ${misc:Depends},
         ${perl:Depends},
         openqa-client (>= ${binary:Version}),
         os-autoinst (>= 4.6.1631608584),
         libsql-splitstatement-perl,
         libmojo-ioloop-readwriteprocess-perl,
         libnet-dns-native-perl,
         vde2,
         libfile-map-perl,
Recommends: qemu,
            libminion-backend-sqlite-perl,
Description: automatic Operating System testing framework (worker)
 openQA is a testing framework that allows you to run tests on pretty-much
 anything that you can get 'remote' control of (most often, anything you can run
 in a VM and point VNC at). This allows testing of things including GUI
 applications, system boot-up (BIOS, bootloaders, kernels), installers and whole
 operating systems.
 .
 Tests (using Perl syntax) generally consist of little more than sequences like:
 assert_and_click 'some_icon'; assert_screen 'some_prompt'; send_key 'ret';
 which are run using the os-autoinst test engine, by a worker. The tags named in
 scripts can then be associated with 'needles' (elements of screenshots) via the
 webUI (either from past tests, or while controlling a live test). Other testing
 possibilities include: serial-connected headless systems, multi-host networked
 tests, and non-VM 'real' systems.
 .
 This package is to be installed on a worker system (which may also be acting as
 a server). Workers register with a server (or perhaps multiple servers), and
 can then accept jobs, and run tests (using the os-autoinst test engine).

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

include /usr/share/dpkg/pkg-info.mk

%:
	dh $@

SCRATCH_DIR := $(shell mktemp -d $${TMPDIR:-/tmp}/openqa_build.XXXXXX)

ifneq (,$(filter x-with-npm,$(DEB_BUILD_PROFILES)))
override_dh_gencontrol:
	dh_gencontrol -- -v$(shell dpkg-parsechangelog -SVersion | sed -E 's/^([^-]*-[0-9]*)/\1~~~NPM~~/')
endif

setup_node_modules:
ifneq (,$(filter x-with-npm,$(DEB_BUILD_PROFILES)))
#	this is here to enable test builds to compare with the way upstream would build it
#	NEVER use 'x-with-npm' profile for a real build!
	HOME=$${TMPDIR:-/tmp}/fake_npm_home npm install
	mv node_modules node_modules_npm
	-ls -lR node_modules_npm
endif
	mkdir -p node_modules
	for d in javascript nodejs sass; do [ -e "node_modules/_u_s_$$d" ] || ln -s /usr/share/$$d node_modules/_u_s_$$d; done
	[ -e node_modules/_u_s_ffa ] || ln -s /usr/share/fonts-fork-awesome node_modules/_u_s_ffa

override_dh_auto_build:
	# ensure that there are no remote references left
	! grep http assets/assetpack.def

override_dh_auto_install: setup_node_modules
	# install READMEs in /etc/.../*.d/ dirs
	for cfg in openqa.ini workers.ini database.ini client.conf; do \
		ext=$${cfg#*.}; \
		dst_dir=debian/tmp/etc/openqa/$$cfg.d; \
		R_cfg=debian/README.$$cfg; \
		mkdir -p $$dst_dir; \
		if [ -e "$$R_cfg" ]; then \
			cp "$$R_cfg" $$dst_dir/README; \
		else \
			sed -E "s/<CONFNAME>/$$cfg/" debian/README.drop-in_configs.in > $$dst_dir/README; \
		fi; \
	done

	dh_auto_install -- SHELL="/bin/bash" GENERATE_PACKED_ASSETS_FAILS_ON_MISSING_ASSETS=1

	dh_apparmor --profile-name=usr.share.openqa.script.openqa -p openqa
	dh_apparmor --profile-name=usr.share.openqa.script.worker -p openqa-worker

override_dh_installdocs:
	dh_installdocs -X .gitignore

execute_after_dh_install:
	# make #! lines Debian Perl/Python Policy compliant
	find $(CURDIR)/debian/openqa*/usr/share/openqa -type f -print0 | \
		xargs -r0 sed -i -e '1s%^\(#!/usr/bin/\)env \(perl\|python3\)%\1\2%'
	# apache & nginx vhost configs are found in .../sites-available on Debian
	sed -i 's#\bvhosts\.d\b#sites-available#' \
		$(CURDIR)/debian/openqa/usr/share/openqa/script/configure-web-proxy \
		$(CURDIR)/debian/openqa/etc/*/sites-available/openqa*.conf.template

execute_after_dh_fixperms:
	chmod -x debian/openqa/etc/logrotate.d/openqa
	chmod +x debian/openqa/usr/share/openqa/dbicdh/*/upgrade/*-*/0*-*.pl

# add some tests that fail on Debian to the unstables list
EXTRA_UNSTABLES := t/03-auth.t t/09-job_clone.t t/24-worker-engine.t t/37-limit_assets.t t/40-script_load_dump_templates.t t/ui/27-plugin_obs_rsync.t t/ui/27-plugin_obs_rsync_gru.t t/ui/27-plugin_obs_rsync_obs_status.t t/api/02-iso-yaml.t t/api/08-jobtemplates.t t/api/14-plugin_obs_rsync.t t/api/14-plugin_obs_rsync_async.t t/api/16-webhooks.t
# when building with unshare, these attempts to nest unshare fail
EXTRA_UNSTABLES += t/32-openqa_client-script.t t/40-openqa-clone-job.t t/40-script_openqa-clone-custom-git-refspec.t
# silence tests that don't backport to fastrack
EXTRA_UNSTABLES += t/14-grutasks-git.t t/10-jobs.t t/api/16-webhooks.t t/api/04-jobs.t t/api/09-comments.t


override_dh_auto_test: setup_node_modules
	ln -s ../node_modules t/
	cp tools/unstable_tests.txt tools/unstable_tests.txt.bak
	for i in $(EXTRA_UNSTABLES); do echo $$i >> tools/unstable_tests.txt; done
	export CONTAINER_TEST=0 ; \
		PATH=$$PATH:$$(ls -d /usr/lib/postgresql/*/bin) \
		PROVE_ARGS='-v' \
		make test-t test-ui test-api SHELL="bash -x" CI=1 OPENQA_TEST_TIMEOUT_SCALE_CI=10 TEST_PG_PATH=${SCRATCH_DIR}/DB
	mv tools/unstable_tests.txt.bak tools/unstable_tests.txt

execute_before_dh_auto_clean:
	rm -rf node_modules/
	rm -rf t/pool*
	rm -rf t/data/openqa/share/factory/other
	rm -rf t/data/openqa/share/factory/foo
	rm -rf t/data/openqa/pool
	rm -f test_vars.json
	rm -rf .tidyall.d/
	rm -rf .tidyall
	rm -f t/data/openqa/share/factory/hdd/hdd_image.qcow2
	rm -f t/data/openqa/share/factory/hdd/00099963-hdd_image.qcow2
	rm -f t/data/openqa/share/factory/foo/some-repo
	rm -rf t/data/openqa/testresults/ .sass-cache/ assets/cache
	rm -f assets/assetpack.db job.json t/data/openqa/pool/1/.locked t/data/openqa/pool/1/t/data/openqa/pool/1/.locked t/data/openqa/pool/1/t/data/openqa/pool/1/t/data/openqa/pool/1/.locked t/data/openqa/pool/1/t/data/openqa/pool/1/t/data/openqa/pool/1/worker-log.txt t/data/openqa/pool/1/t/data/openqa/pool/1/worker-log.txt t/data/openqa/share/factory/iso/Core-7.2.iso t/data/openqa/share/tests/opensuse/needles/inst-timezone-text.json t/data/openqa/webui/cache/asset-status.json
	rm -f t/data/openqa/share/factory/hdd/00099963-hdd_image3.qcow2 t/data/openqa/share/factory/hdd/00099963-hdd_image7.qcow2 t/data/openqa/share/factory/hdd/hdd_image2.qcow2 t/data/openqa/share/factory/hdd/hdd_image5.qcow2 t/data/openqa/share/factory/other/00099963-hdd_image3.xml t/data/openqa/share/factory/other/00099963-hdd_image4.xml
	rm -rf ${SCRATCH_DIR}
	# FIXME: no idea why I need to remove this file, as I'm also removing it via a patch, but salsa hates me otherwise
	rm -f assets/stylesheets/cropper.css

pod2man_opts := --errors=stderr --section=1 --center "openQA Documentation" --release 'openQA $(DEB_VERSION_UPSTREAM)'
execute_before_dh_installman:
	make build-manpages -- DESTDIR=debian/tmp OPENQA_VERSION=$(DEB_VERSION_UPSTREAM)

## openqa 4.6.1748615746.d50d8e243

=== Makefile ===
--- 
+++ 
@@ -71,7 +71,7 @@
 		install -m 644 -D --target-directory="$(DESTDIR)/usr/share/openqa/$${f%/*}" "$$f";\
 	done
 
-	for i in db images testresults pool ; do \
+	for i in db images testresults pool/1 cache webui/cache backup; do \
 		mkdir -p "$(DESTDIR)"/var/lib/openqa/$$i ;\
 	done
 # shared dirs between openQA web and workers + compatibility links
@@ -96,7 +96,7 @@
 		install -m 644 etc/nginx/vhosts.d/$$i "$(DESTDIR)"/etc/nginx/vhosts.d ;\
 	done
 
-	for prefix in usr/etc etc; do \
+	for prefix in etc; do \
 		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa ;\
 		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa/client.conf.d ;\
 		install -d -m 755 "$(DESTDIR)"/$$prefix/openqa/workers.ini.d ;\
@@ -177,9 +177,6 @@
 	@touch node_modules
 
 .PHONY: test
-ifeq ($(TRAVIS),true)
-test: run-tests-within-container
-else
 ifeq ($(CHECKSTYLE),0)
 checkstyle_tests =
 else
@@ -194,7 +191,6 @@
 ifeq ($(HELM_TEST),1)
 ifeq ($(TESTS),)
 test: test-helm-chart
-endif
 endif
 endif

=== debian/changelog ===
openqa (4.6.1748615746.d50d8e243-1~fto12+1) bookworm-fasttrack; urgency=medium

  * Update to new upstream version 4.6.1748615746.d50d8e243.
  * openqa.install: add systemd/*/openqa-dump-db.*
  * apparmor: add Debian path for tesseract data

 -- Philip Hands <phil@hands.com>  Sat, 14 Jun 2025 16:30:19 +0200

## openqa 4.6.1749835125.6b21a3a03

=== debian/changelog ===
openqa (4.6.1749835125.6b21a3a03-1~fto12+1) bookworm-fasttrack; urgency=medium

  * Update to new upstream version 4.6.1749835125.6b21a3a03.

 -- Philip Hands <phil@hands.com>  Sun, 15 Jun 2025 16:25:34 +0200

openqa (4.6.1748615746.d50d8e243-1~fto12+2) bookworm-fasttrack; urgency=medium

  * openqa-common: depend: libfeature-compat-try-perl

 -- Philip Hands <phil@hands.com>  Sat, 14 Jun 2025 20:41:03 +0200

=== debian/control ===
--- 
+++ 
@@ -86,6 +86,7 @@
                node-d3,
                node-dagre-d3-renderer,
                node-anser,
+               libfeature-compat-try-perl,
 ### for testcases
                libperl-critic-perl <!nocheck>,
                libperl-critic-community-perl <!nocheck>,
@@ -118,7 +119,6 @@
                libtext-glob-perl <!nocheck>,
                libaliased-perl <!nocheck>,
                libarchive-tools <!nocheck>,
-               libfeature-compat-try-perl <!nocheck>,
 #              for avoiding assetpack downloads
                fonts-fork-awesome,
                fonts-roboto-fontface,
@@ -239,6 +239,7 @@
          libtime-moment-perl,
          libcpanel-json-xs-perl,
          libmoose-perl,
+         libfeature-compat-try-perl,
 Recommends:
          git-lfs,
 Description: automatic Operating System testing framework (common files)
@@ -299,5 +300,3 @@
  .
  This package is to be installed on a worker system (which may also be acting as
  a server). Workers register with a server (or perhaps multiple servers), and
- can then accept jobs, and run tests (using the os-autoinst test engine).
-

## openqa 5.1751519172.720c194b1

=== Makefile ===
--- 
+++ 
@@ -59,6 +59,38 @@
 	@echo Call one of the available targets:
 	@sed -n 's/\(^[^.#[:space:]A-Z]*\):.*$$/\1/p' Makefile | uniq
 	@echo See docs/Contributing.asciidoc for more details
+
+man_names = openqa-cli openqa-client openqa-load-templates openqa-dump-templates openqa-clone-job openqa-validate-yaml openqa-label-all
+manpages = $(addprefix $(man_dir)/,$(addsuffix .1,$(man_names)))
+man_dir = build/man1
+
+$(man_dir):
+	mkdir -p $@
+
+define run-pod2man =
+pod2man --errors=stderr --section=1 \
+	--center "openQA Documentation" \
+	--name=$(notdir $(basename $@)) $< $@
+endef
+
+$(man_dir)/openqa-label-all.1: script/openqa-label-all
+	argparse-manpage --pyfile $< --function get_parser --author "various authors:" --author-email "https://progress.opensuse.org/projects/openqav3" --project-name openqa --url "https://github.com/os-autoinst/openQA" | grep -v '^\.br$$' >$@
+
+$(man_dir)/openqa-%.1 $(man_dir)/%.1: script/%
+	$(run-pod2man)
+
+$(man_dir)/openqa-%-templates.1: script/%_templates
+	$(run-pod2man)
+
+$(man_dir)/openqa-cli.1: lib/OpenQA/CLI.pm
+	$(run-pod2man)
+
+.PHONY: build-manpages
+build-manpages: $(man_dir) $(manpages)
+
+.PHONY: clean
+clean:
+	-rm -r build
 
 .PHONY: install-generic
 install-generic:
@@ -245,22 +277,3 @@
 	test -d $(TEST_PG_PATH) && (pg_ctl -D $(TEST_PG_PATH) -s status >&/dev/null || pg_ctl -D $(TEST_PG_PATH) -s start) || ./t/test_postgresql $(TEST_PG_PATH)
 
 # prepares running the tests within a container (eg. pulls os-autoinst) and then runs the tests considering
-# the test matrix environment variables
-# note: This is supposed to run within the container unlike `launch-container-to-run-tests-within`
-#       which launches the container.
-.PHONY: run-tests-within-container
-run-tests-within-container:
-	tools/run-tests-within-container
-
-ifeq ($(COVERAGE),1)
-COVERDB_SUFFIX ?=
-# We use JSON::PP because there is a bug producing a (harmless) 'redefined'
-# warning when using Devel::Cover and Cpanel::JSON::XS
-# https://progress.opensuse.org/issues/90371
-#
-# CoverageWorkaround: We use a workaround with Syntax::Keyword::Try::Deparse
-# because we would get warnings:
-#     unexpected OP_CUSTOM (catch) at .../B/Deparse.pm line 1667.
-# because Feature::Compat::Try uses OP_CUSTOM for perl < 5.40
-# https://metacpan.org/pod/Feature::Compat::Try#COMPATIBILITY-NOTES
-# https://rt.cpan.org/Transaction/Display.html?id=1992941

=== debian/changelog ===
openqa (5.1751519172.720c194b1-1~fto12+1) bookworm-fasttrack; urgency=medium

  * Update to new upstream version 5.1751519172.720c194b1.
  * embed Roboto font (to avoid apache blocking symlinks)

 -- Philip Hands <phil@hands.com>  Thu, 03 Jul 2025 08:19:10 +0200

openqa (5.1750858025.b9f0656f0-1~fto12+2) bookworm-fasttrack; urgency=medium

  [ Philip Hands ]
  * avoid broken sorting caused by 'serverSide: true'

  [ Roland Clobus ]
  * openqa: depend on libtext-glob-perl

 -- Philip Hands <phil@hands.com>  Wed, 25 Jun 2025 21:55:27 +0200

openqa (5.1750858025.b9f0656f0-1~fto12+1) bookworm-fasttrack; urgency=medium

  * Update to new upstream version 5.1750858025.b9f0656f0.

 -- Philip Hands <phil@hands.com>  Wed, 25 Jun 2025 19:10:22 +0200

=== debian/control ===
--- 
+++ 
@@ -87,6 +87,8 @@
                node-dagre-d3-renderer,
                node-anser,
                libfeature-compat-try-perl,
+               python3-argparse-manpage,
+               python3-distutils,
 ### for testcases
                libperl-critic-perl <!nocheck>,
                libperl-critic-community-perl <!nocheck>,
@@ -154,6 +156,7 @@
          libmojo-sqlite-perl,
          libjson-validator-perl,
          libtext-diff-perl,
+         libtext-glob-perl,
          libyaml-pp-perl,
          libdatetime-format-pg-perl,
          libminion-perl (>= 10.25),
@@ -162,7 +165,6 @@
          postgresql,
          libclass-c3-componentised-perl,
          fonts-fork-awesome,
-         fonts-roboto-fontface,
          libjs-jquery-datatables,
          libjs-codemirror,
          libjs-jquery,
@@ -299,4 +301,3 @@
  tests, and non-VM 'real' systems.
  .
  This package is to be installed on a worker system (which may also be acting as
- a server). Workers register with a server (or perhaps multiple servers), and

=== debian/rules ===
--- 
+++ 
@@ -60,6 +60,9 @@
 		$(CURDIR)/debian/openqa/usr/share/openqa/script/configure-web-proxy \
 		$(CURDIR)/debian/openqa/etc/*/sites-available/openqa*.conf.template
 
+	# grab local copy of Roboto, as symlinks to other directories don't always work by default
+	cp /usr/share/fonts/truetype/roboto-fontface/roboto/Roboto-Regular.ttf debian/openqa/usr/share/openqa/public/fonts/
+
 execute_after_dh_fixperms:
 	chmod -x debian/openqa/etc/logrotate.d/openqa
 	chmod +x debian/openqa/usr/share/openqa/dbicdh/*/upgrade/*-*/0*-*.pl

## openqa 5.1754383059.0426baa1d

=== Makefile ===
--- 
+++ 
@@ -205,7 +205,7 @@
 # Ensure npm packages are installed and up-to-date (unless local-npm-registry is installed; in this case we can
 # assume installing npm packages is taken care of separately, e.g. in builds on OBS)
 node_modules: package-lock.json
-	@which local-npm-registry >/dev/null 2>&1 || npm install --no-audit --no-fund
+	@which local-npm-registry >/dev/null 2>&1 || npm install --no-audit --no-fund --ignore-scripts
 	@touch node_modules
 
 .PHONY: test
@@ -276,4 +276,3 @@
 setup-database:
 	test -d $(TEST_PG_PATH) && (pg_ctl -D $(TEST_PG_PATH) -s status >&/dev/null || pg_ctl -D $(TEST_PG_PATH) -s start) || ./t/test_postgresql $(TEST_PG_PATH)
 
-# prepares running the tests within a container (eg. pulls os-autoinst) and then runs the tests considering

=== docs/asciinema/Makefile ===
YAML_FILES=$(wildcard *.yaml)
WEBM_FILES=$(YAML_FILES:.yaml=.webm)
THEME=monokai
BAT_THEME=Monokai Extended

.PHONY: all
all: build run

.PHONY: cast
cast: $(WEBM_FILES)

%.cast:%.yaml
	autocast --overwrite $< $@

%.gif: %.cast
	agg --theme $(THEME) $< $@

%.webm: %.gif
	ffmpeg -i $< -c:v libvpx-vp9 -b:v 0 -crf 30 -pix_fmt yuv420p $@

.PHONY: build
build:
	podman build . -t autocast

.PHONY: run
run:
	podman run -e BAT_THEME="$(BAT_THEME)" --rm -ti -v .:/work --privileged --device /dev/kvm autocast make cast

=== external/os-autoinst-common/Makefile ===
.PHONY: help
help:
	@echo Call one of the available targets:
	@sed -n 's/\(^[^.#[:space:]A-Z]*\):.*$$/\1/p' Makefile | uniq

.PHONY: update-deps
update-deps:
	tools/update-deps --cpanfile cpanfile

.PHONY: test
test: test-tidy test-critic test-yaml test-author test-t

.PHONY: test-tidy
test-tidy:
	tools/tidyall --all --check-only

.PHONY: test-critic
test-critic:
	tools/perlcritic --quiet .

.PHONY: test-yaml
test-yaml:
	yamllint --strict ./

.PHONY: test-author
test-author:
	prove -l -r xt/

.PHONY: test-t
test-t:
	prove -l -r t/

=== debian/changelog ===
openqa (5.1754383059.0426baa1d-2) unstable; urgency=medium

  * openqa-client: dep libgetopt-long-descriptive-perl (closes: #1115544)
  * recommend qemu-system (rather than qemu) (closes: #1116156)
  * depends: vde-switch (replacing obsolete vde2)
  * only create the server ('openqa') package for debian-fasttrack
    (see NEWS.Debian for more details)

 -- Philip Hands <phil@hands.com>  Sat, 18 Oct 2025 00:56:16 +0200

openqa (5.1754383059.0426baa1d-1~fto13+1) trixie-fasttrack; urgency=medium

  * rebuild for trixie-fasttrack

 -- Philip Hands <phil@hands.com>  Sat, 09 Aug 2025 14:16:46 +0200

openqa (5.1754383059.0426baa1d-1~fto12+1) bookworm-fasttrack; urgency=medium

  * Update to new upstream version 5.1754383059.0426baa1d.
  * stop shipping deprecated client script (closes: #1110395)
  * openqa-cli lost its pod, so drop manpage creation

 -- Philip Hands <phil@hands.com>  Wed, 06 Aug 2025 23:09:36 +0200

=== debian/control ===
--- 
+++ 
@@ -87,8 +87,9 @@
                node-dagre-d3-renderer,
                node-anser,
                libfeature-compat-try-perl,
+               python3-requests,
                python3-argparse-manpage,
-               python3-distutils,
+#               python3-distutils,
 ### for testcases
                libperl-critic-perl <!nocheck>,
                libperl-critic-community-perl <!nocheck>,
@@ -113,8 +114,6 @@
                libclass-c3-componentised-perl <!nocheck>,
                libtest-most-perl <!nocheck>,
                libyaml-pp-perl <!nocheck>,
-               python3 <!nocheck>,
-               python3-requests <!nocheck>,
                yamllint <!nocheck>,
                libfilesys-df-perl <!nocheck>,
                libfile-map-perl <!nocheck>,
@@ -144,6 +143,7 @@
 
 Package: openqa
 Architecture: all
+Build-Profiles: <!pkg.openqa.noserver>
 Depends: ${misc:Depends}, ${perl:Depends},
          openqa-common (>= ${binary:Version}),
          openqa-client (>= ${binary:Version}),
@@ -259,6 +259,7 @@
          libjson-perl,
          libconfig-inifiles-perl,
          libdata-dump-perl,
+         libgetopt-long-descriptive-perl,
          libmojolicious-perl (>= 9.34),
          openqa-common (= ${binary:Version}),
 Suggests: python3,
@@ -281,9 +282,9 @@
          libsql-splitstatement-perl,
          libmojo-ioloop-readwriteprocess-perl,
          libnet-dns-native-perl,
-         vde2,
+         vde-switch,
          libfile-map-perl,
-Recommends: qemu,
+Recommends: qemu-system,
             libminion-backend-sqlite-perl,
 Description: automatic Operating System testing framework (worker)
  openQA is a testing framework that allows you to run tests on pretty-much

=== debian/rules ===
--- 
+++ 
@@ -5,6 +5,19 @@
 
 %:
 	dh $@
+
+README_CFGS := workers.ini database.ini client.conf
+ifeq (yes,$(shell dpkg-vendor --is Debian && echo yes))
+# let's limit the removal of the webUI to actual Debian,
+# rather than also inflicting this on downstreams.
+# Downstreams that want to have the webUI split out should ask to be included (patches welcome)
+SUITE := $(shell dpkg-parsechangelog -S Distribution)
+endif
+ifneq (,$(filter $(SUITE),stable testing unstable trixie-backports))
+export DEB_BUILD_PROFILES += pkg.openqa.noserver
+else
+README_CFGS += openqa.ini
+endif
 
 SCRATCH_DIR := $(shell mktemp -d $${TMPDIR:-/tmp}/openqa_build.XXXXXX)
 
@@ -31,7 +44,7 @@
 
 override_dh_auto_install: setup_node_modules
 	# install READMEs in /etc/.../*.d/ dirs
-	for cfg in openqa.ini workers.ini database.ini client.conf; do \
+	for cfg in $(README_CFGS); do \
 		ext=$${cfg#*.}; \
 		dst_dir=debian/tmp/etc/openqa/$$cfg.d; \
 		R_cfg=debian/README.$$cfg; \
@@ -55,27 +68,31 @@
 	# make #! lines Debian Perl/Python Policy compliant
 	find $(CURDIR)/debian/openqa*/usr/share/openqa -type f -print0 | \
 		xargs -r0 sed -i -e '1s%^\(#!/usr/bin/\)env \(perl\|python3\)%\1\2%'
+
+ifeq (,$(filter pkg.openqa.noserver,$(DEB_BUILD_PROFILES)))
 	# apache & nginx vhost configs are found in .../sites-available on Debian
 	sed -i 's#\bvhosts\.d\b#sites-available#' \
 		$(CURDIR)/debian/openqa/usr/share/openqa/script/configure-web-proxy \
 		$(CURDIR)/debian/openqa/etc/*/sites-available/openqa*.conf.template
-
 	# grab local copy of Roboto, as symlinks to other directories don't always work by default
 	cp /usr/share/fonts/truetype/roboto-fontface/roboto/Roboto-Regular.ttf debian/openqa/usr/share/openqa/public/fonts/
 
 execute_after_dh_fixperms:
 	chmod -x debian/openqa/etc/logrotate.d/openqa
 	chmod +x debian/openqa/usr/share/openqa/dbicdh/*/upgrade/*-*/0*-*.pl
+endif
 
 # add some tests that fail on Debian to the unstables list
-EXTRA_UNSTABLES := t/03-auth.t t/09-job_clone.t t/24-worker-engine.t t/37-limit_assets.t t/40-script_load_dump_templates.t t/ui/27-plugin_obs_rsync.t t/ui/27-plugin_obs_rsync_gru.t t/ui/27-plugin_obs_rsync_obs_status.t t/api/02-iso-yaml.t t/api/08-jobtemplates.t t/api/14-plugin_obs_rsync.t t/api/14-plugin_obs_rsync_async.t t/api/16-webhooks.t
+EXTRA_UNSTABLES := t/*/*_obs_* t/03-auth.t t/09-job_clone.t t/24-worker-engine.t t/37-limit_assets.t t/40-script_load_dump_templates.t t/api/02-iso-yaml.t t/api/08-jobtemplates.t t/api/16-webhooks.t
 # when building with unshare, these attempts to nest unshare fail
 EXTRA_UNSTABLES += t/32-openqa_client-script.t t/40-openqa-clone-job.t t/40-script_openqa-clone-custom-git-refspec.t
 # silence tests that don't backport to fastrack
 EXTRA_UNSTABLES += t/14-grutasks-git.t t/10-jobs.t t/api/16-webhooks.t t/api/04-jobs.t t/api/09-comments.t
 
-
 override_dh_auto_test: setup_node_modules
+ifneq (,$(filter pkg.openqa.noserver,$(DEB_BUILD_PROFILES)))
+	: # skip tests when we do a partial (noserver) build
+else
 	ln -s ../node_modules t/
 	cp tools/unstable_tests.txt tools/unstable_tests.txt.bak
 	for i in $(EXTRA_UNSTABLES); do echo $$i >> tools/unstable_tests.txt; done
@@ -84,6 +101,7 @@
 		PROVE_ARGS='-v' \
 		make test-t test-ui test-api SHELL="bash -x" CI=1 OPENQA_TEST_TIMEOUT_SCALE_CI=10 TEST_PG_PATH=${SCRATCH_DIR}/DB
 	mv tools/unstable_tests.txt.bak tools/unstable_tests.txt
+endif
 
 execute_before_dh_auto_clean:
 	rm -rf node_modules/

=== debian/watch ===
version=4
opts="mode=git, pretty=4.6.%ct.%h" \
   https://github.com/os-autoinst/openQA \
   HEAD debian uupdate
